;************************************************************************
;*									*
;*				DCF77 LCD Clock				*
;*									*
;*			Author: P. Dannegger				*
;*				danni@specs.de				*
;*									*
;************************************************************************
.nolist
.include "clock.h"
.include "lcd.mac"
.list
.listmac
	rjmp	init
;-------------------------------------------------------------------------
	.org	ovf0addr
.include "ovf0int.inc"
;-------------------------------------------------------------------------
init:	ldi	zl, low( 2 * calbyte )
	ldi	zh, high( 2 * calbyte )
	lpm					;read calibration from Flash
	out	osccal, r0

	sbi	portb, dcf77_data		;activate pull up

	ldi	a0, 1<<CS01^1<<CS00
	out	TCCR0, a0			;prescaler 1/64
	ldi	a0, 1<<TOIE0
	out	TIMSK, a0			;enable timer interrupt

	rcall	lcd_init

	ldi	a0, reload1sec
	mov	reload, a0
	ldi	a0, 59
	mov	delta, a0

	ldi	second, 0
	ldi	minute, 0
	ldi	hour, 0
	ldi	weekday, 1
	ldi	day, 1
	ldi	month, 1
	ldi	year, 1

	sei
;-------------------------------------------------------------------------
main:
display_clock_ret:
	rcall	decodedcf77
	brts	_mai1				;display new time
	sbrs	flags, second1
	rjmp	main
	rcall	clock_inc			;count time
_mai1:
	cbr	flags, 1<<second1
	rjmp	display_clock_inline
;-------------------------------------------------------------------------
.include "lcd12s.inc"
.include "clockd.inc"
.include "dcf77.inc"
.include "div60.inc"
;-------------------------------------------------------------------------
	.org	0x01FF
calbyte:
	.db	0x45, 0xFF
;------------------------------------------------------------------------
